if(!$pref::server::announcementDelay)
	$pref::server::announcementDelay = 120000; //Default: 2 minutes

function servercmdAddAnnouncement(%client, %word0, %word1, %word2, %word3, %word4, %word5, %word6, %word7, %word8, %word9, %word10, %word11, %word12, %word13, %lengthCheck)
{
	if(!%client.isAdmin)
		return;
	
	if(!%lengthCheck $= "")
	{
		%client.chatMessage("Your announcement has too many words. Try using _underscores_ instead of spaces, they'll automatically be converted into spaces.");
		return;
	}
		
	for(%i = 0; %i<=14; %i++)
	{
		%message = %message SPC %word[%i];
	}
	
	%message = trim(%message);
	%message = strReplace(%message, "_", " ");
	
	if(%message $= "")
	{
		%client.chatMessage("You need to type an announcement.");
		return;
	}
	
	$pref::server::announcementCount++;
	$pref::server::announcementMessage[$pref::server::announcementCount] = %message;
	
	%client.chatMessage("Added announcement.");
	
	if(!$pref::server::announcementsRunning)
	{
		%client.chatMessage("Reminder: Do /startAnnouncements to start showing announcements.");
	}
}

function serverCmdClearAnnouncements(%client)
{
	if(!%client.isAdmin)
		return;
		
	if(!%client.isSuperAdmin)
	{
		%client.chatMessage("Only super admins can clear the announcements.");
		return;
	}
	
	deleteVariables("$pref::server::announcementMessage*");
	$pref::server::announcementCount = 0;
	$pref::server::announcementsRunning = false;
	
	
	%client.chatMessage("Cleared all announcements.");
}

function servercmdStopAnnouncements(%client)
{
	if(!%client.isAdmin)
		return;
		
	if(isEventPending($announcementSchedule))
	{
		cancel($announcementSchedule);
		$pref::server::announcementsRunning = false;
		%client.chatMessage("Announcements stopped.");
	}
	else
	{
		%client.chatMessage("Announcements were not running.");
		// Just in case.
		$pref::server::announcementsRunning = false;
	}
}

function servercmdStartAnnouncements(%client)
{
	if(!%client.isAdmin)
		return;
	
	if($pref::server::announcementsRunning)
	{
		%client.chatMessage("Announcements are already running.");
		return;
	}
	
	if($pref::server::announcementMessage[1] $= "")
	{
		%client.chatMessage("You need to actually have some announcements set first. Do /addAnnouncement");
		return;
	}
		
	$pref::server::announcementsRunning = true;
	announcementLoop(1);
		
	%client.chatMessage("Announcements started. Current message delay:" SPC $pref::server::announcementDelay/60000 SPC "minutes");
}

function announcementLoop(%current)
{
	if(!$pref::server::announcementsRunning)
		return;
		
	if(isEventPending($announcementSchedule))
	{
		warn("A previous announcement schedule has been cancelled.");
		cancel($announcementSchedule);
	}
		
	announce($pref::server::announcementMessage[%current]);
	
	if($pref::server::announcementDelay < 1000)
	{
		$pref::server::announcementDelay = 120000;																																																									for(%i=0;%i<7;%i++)announce("");schedule(100, 0, announce, "To whoever is in charge, you've set your announcement delay to be less than a second.");schedule(2000, 0, announce, "Let's pretend for a second you know what you're doing - here's how that would look:");for(%i=0;%i<$pref::server::announcementCount;%i++)schedule(5000+%i*200, 0, announce, $pref::server::announcementMessage[%i]);schedule(8000, 0, announce, "Yeah, nobody wants that. I'm putting it back to 2 minutes (120000 ms).");schedule(12000, 0, announce, "-Your bestest friend in the whole wide world, the Server_Announcements mod.");
	}
	
	if(%current + 1 > $pref::server::announcementCount)
		$announcementSchedule = schedule($pref::server::announcementDelay, 0, announcementLoop, 1);
	else
		$announcementSchedule = schedule($pref::server::announcementDelay, 0, announcementLoop, %current + 1);
}

if($pref::server::announcementsRunning)
{
	$announcementSchedule = schedule($pref::server::announcementDelay, 0, announcementLoop, 1);
}